=== src/tests/unit/CMakeLists.txt ===
if (${opencoarrays_aware_compiler})
  add_subdirectory(simple)
  add_subdirectory(send-get)
  add_subdirectory(init_register)
  add_subdirectory(collectives)
  add_subdirectory(sync)
  add_subdirectory(events)
  if(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7)
    add_subdirectory(fail_images)
  endif()
else()
  add_subdirectory(extensions)
endif()
