=== src/tests/integration/events/CMakeLists.txt ===
add_executable(asynchronous_hello_world async-hello.F90)
target_link_libraries(asynchronous_hello_world OpenCoarrays)
