=== src/tests/unit/fail_images/CMakeLists.txt ===
add_executable(image_fail_test_1 image_fail_test_1.f90)
target_link_libraries(image_fail_test_1 OpenCoarrays)

add_executable(image_status_test_1 image_status_test_1.f90)
target_link_libraries(image_status_test_1 OpenCoarrays)

add_executable(image_fail_and_sync_test_1 image_fail_and_sync_test_1.f90)
target_link_libraries(image_fail_and_sync_test_1 OpenCoarrays)

add_executable(image_fail_and_sync_test_2 image_fail_and_sync_test_2.f90)
target_link_libraries(image_fail_and_sync_test_2 OpenCoarrays)

add_executable(image_fail_and_sync_test_3 image_fail_and_sync_test_3.f90)
target_link_libraries(image_fail_and_sync_test_3 OpenCoarrays)

add_executable(image_fail_and_status_test_1 image_fail_and_status_test_1.f90)
target_link_libraries(image_fail_and_status_test_1 OpenCoarrays)

add_executable(image_fail_and_get_test_1 image_fail_and_get_test_1.f90)
target_link_libraries(image_fail_and_get_test_1 OpenCoarrays)

add_executable(image_fail_and_failed_images_test_1 image_fail_and_failed_images_test_1.f90)
target_link_libraries(image_fail_and_failed_images_test_1 OpenCoarrays)

add_executable(image_fail_and_stopped_images_test_1 image_fail_and_stopped_images_test_1.f90)
target_link_libraries(image_fail_and_stopped_images_test_1 OpenCoarrays)
