=== debian/changelog ===
open-coarrays (1.9.1-1) unstable; urgency=medium

  * New upstream release
  * Set libopencoarrys-dev as M-A: foreign
  * Standards-Version: 4.0.1

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 13 Aug 2017 11:25:16 +0100

open-coarrays (1.9.0-1) experimental; urgency=medium

  * New upstream release
  * Breaks/Replaces for libcorrays0d. Closes: #863676

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 01 Jun 2017 10:03:23 +0100

open-coarrays (1.8.10-1) experimental; urgency=medium

  * New upstream release
  * SOVERSION has changed; move rename libcoarrays0d -> libcaf-mpi1

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 10 May 2017 15:42:57 +0100

open-coarrays (1.8.6-2) unstable; urgency=medium

  * Don't build caf_single (won't work on GCC-7); rely on gfortran-internal
    version. Closes: #853586
  * Add missing symlink for so 1.8.6; Closes: #861001
  * Build --no-parallel; fix race condition. Closes: #860853

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 21 Apr 2017 16:48:27 +0100

open-coarrays (1.8.6-1) unstable; urgency=medium

  * New upstream release
    - disable_ns_test.patch, typos.patch, oversubscribe.patch merged upstream
  * Add debian/watch file

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 20 Apr 2017 12:03:50 +0100
