=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/opencoarrays-$1\.tar\.gz/ \
  https://github.com/sourceryinstitute/OpenCoarrays/tags .*/v?(\d\S+)\.tar\.gz
